#!/usr/bin/perl -w

# Pragmas/Best practice options
#
#use warnings;
#use strict;

#use CGI qw/:standard/;
use LWP::Simple;
use URI::URL;
use IO::Handle;
#
#***********************************************************
#  Tailor Made Software CADViewer Enterprise Conversion Script v 1.8
#  
#  PLEASE CHANGE THE FOLLOWING PATHS
#  REMEMBER TO HAVE \\ FOR PC PATH SEPARATORS (i.e "C\\temp\\)
#
#***********************************************************

# $tempFolder = "C:/webroot/tailormade.com/web/demo/CV7/tempdrawings/";
# $autoxchange_path = "C:/webroot/tailormade.com/web/FCM/";
# $acroxchange_path = "C:/webroot/tailormade.com/web/AcroXchange/";
# $dgnxchange_path  = "C:/webroot/tailormade.com/web/DgnXchange/";
# $hp2xchange_path  = "C:/webroot/tailormade.com/web/Hp2Xchange/";
# $autowhip_path = "C:/webroot/tailormade.com/web/FCM/";

$tempFolder = "/var/www/tempdrawings/";
$autoxchange_path = "/usr/bin/";
$autowhip_path = "/var/www/htdocs/CV-Pro/";

#
#***********************************************************
$method = $ENV{'REQUEST_METHOD'};

if ($method eq "POST") 
{
  # Get the input
  binmode(STDIN);
  $data_size = $ENV{'CONTENT_LENGTH'};
  read(STDIN,$form_info,$data_size);
}
else 
{
   print "Content-type: text/html\n\n";
   print "Client used unsupported method\n";
   print "error";
   exit(0);
}
#***********************************************************
#* Debug : 0 means false -> not in debug code
#*         1 means true -> debug mode
$debugFilelocation = 0;
$debugFile = 0;
#***********************************************************
#   testsave.txt IS THE LOG FILE TO MAKE SURE THAT THIS SCRIPT HAS "WRITE" PERMISSION
#   ON THE SERVER.  IF TESTSAVE.TXT CANNOT BE FOUND, THEN THIS SCRIPT CANNOT
#   WRITE TO A FILE ON THIS SERVER ===> REDLINES CANNOT BE SAVED
#
$myfile = $tempFolder . "testsave.txt";
print "Content-type: text/html\n\n" if $debugFilelocation == 1;
print $tempFolder . "as" if $debugFilelocation == 1;
print "a" if $debugFilelocation == 1;
print $myfile if $debugFilelocation == 1;
open(FILE , ">> " .  $myfile) ||  &sendNotice if $debugFile == 1;
#
#
#   END TESTING "WRITE" PRIVILEDGE ON THE SERVER
#***********************************************************
#
# Split the name-value pairs
print FILE "form_info=$form_info" if $debugFile == 1;
@pairs = split("&DrawingData=", $form_info);
$parameters = $pairs[0];
print FILE "param=$parameters\n" if $debugFile == 1;
@pairs2 = split(/&/,$parameters);
$DrawingData = $pairs[1];
#$dwfcontent="demo.dwf";

foreach $pair (@pairs2)
{
   ($name, $value) = split(/=/, $pair);

#     # Un-Webify plus signs and %-encoding
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

   $FORM{$name} = $value; 
   print FILE  "name=$name, value=$value \n" if $debugFile == 1;
}

$option = $FORM{'Option'};
$urlString = $FORM{'Url'};
$completeFileName = $FORM{'FileName'};
@splitFileName = split(/\//,$completeFileName);
$fileName = @splitFileName[$#splitFileName]; 
$fileName =~ s/%20/\x20/g;
print FILE "urlString=$urlString\n" if $debugFile == 1;
print FILE "filename=$fileName\n" if $debugFile == 1;
print FILE "urlSting=$urlString\n" if $debugFile == 1;
print FILE "option=$option\n" if $debugFile == 1;

if ($option eq "conversion")
{
   if ($urlString eq "false")
   {
      print FILE  "UPLOAD!" if $debugFile == 1;
      $exportFile = join("",$tempFolder,$fileName);
	
      open (EXPORTFILE,"> " . $exportFile) || &sendNotice;
      binmode EXPORTFILE;
      print EXPORTFILE $DrawingData;
      EXPORTFILE->flush;
      close (EXPORTFILE);

      exeFCM($exportFile);
   }
   else
   {
      my $url = url($urlString);
      $content = get($url);   
     my $inputFile = join ("",$tempFolder,$fileName);
      open(TEMP , "> " .  $inputFile) ||  &sendNotice;
      binmode TEMP;
      print TEMP "$content";
      close(TEMP);
      $outputFile = $FORM{'FileName'};
      exeFCM($outputFile,$inputFile);
   }
}

if ($option eq "GetFile")
{

   my $convertedFile = join ("",$tempFolder,$fileName);

   print FILE  "MY CONVERTED FILE:" if $debugFile == 1;
   print FILE  $convertedFile if $debugFile == 1;

   open(TEMP2 , "< " .  $convertedFile) ||  &sendNotice;
   binmode TEMP2;
   $no_bytes=0;
   $block=2048;
   $index=0;
     
   print FILE "before end of file \n" if $debugFile == 1;
     
   until(eof(TEMP2) )
   {
      $byteread = read(TEMP2,$record,$block);
        
      $no_bytes = $no_bytes+$byteread;
      print FILE "no_bytes=$no_bytes; bytesread=$byteread\n" if $debugFile == 1;
      $file[$index] = $record;
      $index++;
   }
   print FILE "total bytes = $no_bytes\nindex=$index\n" if $debugFile == 1;
   $index=1;
   print "Content-type: text/html\n\n";
   foreach $recrd (@file)
   {
      print $recrd;
      print FILE "index=$index\n" if $debugFile == 1;
      ++$index;
   }
#
#    REMOVE TEMPORARY FILE
#
   print FILE "done with sending data\n" if $debugFile == 1;
   close(TEMP2);
   unlink($convertedFile);
   exit(0);
}

#print "ok";
print "filename=$fileName; url=$urlString";
print "dialog";
#
#   PLEASE DO NOT REMOVE IT
#***********************************************************
#

exit(0);

sub exeFCM
{
   $inFile = $_[0];

   print FILE "inFile=$inFile\n" if $debugFile == 1;
   @splitName = split(/\./,$inFile);
   $extension = $splitName[$#splitName];
   print FILE "extension=$extension\n" if $debugFile == 1;
   $extension = lc($extension);
   print FILE "extension=$extension\n" if $debugFile == 1;
   if ($extension ne "/dwg/" )
   {
      print FILE "$extension =~ /dwg/ \n" if $debugFile == 1
   }
   elsif($extension eq "dwg" )
   {
      print FILE "$extension == dwg\n" if $debugFile == 1;
   }
   else
   { 
      print FILE "extension = $extension\n" if $debugFile == 1;
   }

   for ($i=0; $i < $#splitName ; ++$i)
     {
       if($i==0 )
       {
         $outFile = $splitName[$i];
       }
       else
       {
         $outFile = $temp . "." . $splitName[$i];
       }
       $temp = $outFile;
     }

   $outFile = $temp . ".dwf";
   $workFile = $temp . ".w2d"; # Created during conversion, has to be deleted in temp directory
   $format = " -f=dwf -ver=6 -paper";
   $FCM_path="unknown";

   print FILE "extension2 = $extension\n" if $debugFile == 1;

   if ($extension ne "/dwg/" )
   {
      print FILE "extesion2 =~ /dwg/\n" if $debugFile == 1;
   }

   #         if($extension =~ /dwg/ )   
   #|| $extension =~ /dxf/ )
   if ($extension ne "/dwg/" )
   {
      print FILE "extension=$extension\n" if $debugFile == 1;
      print FILE "autowhip_path=$autowhip_path\n" if $debugFile == 1;
      print FILE "autoxchange_path=$autoxchange_path\n" if $debugFile == 1;
      if ($extension ne "/dwg/" )
      {
         #$FCM_path = $autowhip_path . "autowhip -sp=2 ";
         #$FCM_path = $autowhip_path . "autowhip -model -CE=1";
         #$FCM_path = $autoxchange_path . "autoxchange -sp=2 ";
         #$FCM_path = $autoxchange_path . "autoxchange ";
	 # We need to set to the installed converter lastest version is: AX2010
         $FCM_path = $autoxchange_path . "ax2010";
       }
       elsif ($autoxchange_path != "null")
       {
          #$FCM_path = $autoxchange_path . "autoxchange -sp=2 ";
	  $FCM_path = $autoxchange_path . "ax2010 -sp=2 ";
       }
   } 
   elsif ($extension =~ /dgn/ && $dgnxchange_path ne "" )
   {
      $FCM_path = $dgnxchange_path . "dgnxchange ";
      $format = " -f dwf -c ASC";
   }
   elsif ($extension =~ /hp/ || $extension =~ /hp2/ || $extension =~ /hpgl/ || $extension =~ /plt/ || $extension =~ /hgl/)
   {
      #if ($hp2xchange_path != null )
      #{
          $FCM_path = $hp2xchange_path . "hp2xchange ";
          $format = " -F=dwf";

      # }
   }
   elsif ($extension =~ /pdf/ )
   {
      print FILE "PDF Found\n";

      # if($acrowhip_path != null )
      # {
      #     $FCM_path = $acrowhip_path . "acroxchange ";
      # }
      # elsif($acroxchange_path != null )
      # {
           $FCM_path = $acroxchange_path . "acroxchange ";
           $format = " -f dwf -c ASC";
      # }
   }

   print FILE "FCM_path=$FCM_path\n" if $debugFile == 1;
   if ($FCM_path eq "unknown" )
   {
      print "Content-type: text/html\n\n";
      print "Cannot find the path for Conversion tools\n";
      print "error";
      unlink($inFile);
      exit(0);
   }
   else
   {             
      print "Content-type: text/html\n\n";

      # $command = $FCM_path . " -i=" . $inFile . " -o=" . $outFile . $format . " -f=dwf -ver=6 -paper ";             

      # THIS IS FOR AX COMMAND TYPE ONLY

      $command = $FCM_path . ".exe";             
      $arg1 = "-i=" . $inFile;
      $arg2 = "-o=" . $outFile;
      $arg3 = "-f=dwf";
      $arg4 = "-ver=6";
      $arg5 = "-vn=*ALL*";

      print FILE "command=$command\n" if $debugFile == 1;
      print FILE "arg1=$arg1\n" if $debugFile == 1;
      print FILE "arg2=$arg2\n" if $debugFile == 1;
      print FILE "arg3=$arg3\n" if $debugFile == 1;
      print FILE "arg4=$arg4\n" if $debugFile == 1;
      print FILE "arg5=$arg5\n" if $debugFile == 1;

      print "ok\n";

      if ($debugFile == 1)
      {
         @args = ( "strace", "-o", $tempFolder . "strace.txt", $command, $arg1, $arg2, $arg3, $arg4, $arg5 );                         
      }
      else
      {
         @args = ( $command, $arg1, $arg2, $arg3, $arg4, $arg5 );                         
      }                   

      print FILE "args=@args \n" if $debugFile == 1;                         

      $errcheck = system(@args);

      print FILE "Return code 1 - $errcheck -\n" if $debugFile == 1;

      if ($errcheck != 0) 
      {
          print FILE "Error - $errcheck -\n" if $debugFile == 1;
      }

      unlink($inFile);
      unlink($workFile);
      exit(0);
   }
}

sub sendNotice()
{
       
   print "Content-type: text/html\n\n";
   print "Error converting file\n";
   print "error";
   exit(0);
}
